﻿
function CreateUnitsList() {
    Sortable.create(units, {
        group: {
            name: 'pages',
            pull: 'clone',
            put: false
        },
        sort: false,  // sorting inside list
        handle: ".fa-bars",
        animation: 100,
        filter: ".js-remove",
        onFilter: function (evt) {
            var item = evt.item,
            ctrl = evt.target;
            var name = item.id.split("*~*")[1];
            var id = item.id.split("*~*")[0];
            if (Sortable.utils.is(ctrl, ".js-remove")) {  // Click on remove button
                BootstrapDialog.confirm({
                    title: '<b>Dose löschen ?!</b>',
                    message: 'Willst Du wirklich die Dose <b>' + name + '</b> löschen?',
                    type: BootstrapDialog.TYPE_WARNING,
                    btnCancelLabel: 'Nein',
                    btnOKLabel: 'Ja löschen!',
                    btnOKClass: 'btn-warning',
                    callback: function (result) {
                        if (result) {
                            item.parentNode.removeChild(item);
                            DeleteUnit(id);
                        }
                    }
                });
            }
        }
    });
};

function CreatePageList(name) {
    return Sortable.create(name, {
        group: {
            name: 'pages',
            put: ['units']
        },
        handle: ".fa-bars",
        animation: 100,
        filter: ".js-remove",
        onFilter: function (evt) {
            var item = evt.item,
            ctrl = evt.target;

            if (Sortable.utils.is(ctrl, ".js-remove")) {  // Click on remove button                
                var id = item.parentNode.id.replace('page_', '');
                item.parentNode.removeChild(item); // remove sortable item
                UpdatePage(id, sortables[id].toArray());
            }
        },
        onAdd: function (evt) {
            evt.item.innerHTML = evt.item.innerHTML.replace(/<i class="js-remove.*<\/i>/g, '') + ' <i class="pull-right js-remove fa fa-times"></i>';
            evt.item.id = evt.item.id.replace(/\*~*.*/g, '');
        },
        onSort: function (evt) {
            var id = evt.target.id.replace('page_', '');
            UpdatePage(id, sortables[id].toArray());
        }
    });
};

// Unit hinzufügen.
function ADDUnit() {
    var dialog = BootstrapDialog.confirm({
        title: '<b>Eine neue Dose anlegen</b>',
        // Der Inhalt wird hier aus einer Partial geladen!
        message: $('<div></div>').load('partial/AddUnit'),
        type: BootstrapDialog.TYPE_DEFAULT,
        btnCancelLabel: 'Abbrechen',
        btnOKLabel: 'Speichern',
        btnOKClass: 'btn-primary',
        callback: function (result) {
            if (result) {
                $.ajax({
                    type: 'POST',
                    async: false,
                    url: 'config/ADDUnit',
                    data:
                        ({
                            Name: $('#addunit_name').val(),
                            HouseCode: $('#addunit_housecode').val(),
                            UnitCode: $('#addunit_unitcode').val()
                        })
                });
                // Die Seite neuladen um die Unit zu sehen.
                location.reload();
            }
        }
    });
}

function EditUnit(unitID) {
    var dialog = BootstrapDialog.confirm({
        title: '<b>Dose bearbeiten</b>',
        // Der Inhalt wird hier aus einer Partial geladen!
        message: $('<div></div>').load('partial/EditUnit?UnitID=' + unitID),
        type: BootstrapDialog.TYPE_DEFAULT,
        btnCancelLabel: 'Abbrechen',
        btnOKLabel: 'Speichern',
        btnOKClass: 'btn-primary',
        callback: function (result) {
            if (result) {
                $.ajax({
                    type: 'POST',
                    async: false,
                    url: 'config/EditUnit',
                    data:
                        ({
                            UnitID: $('#editunit_id').val(),
                            Name: $('#editunit_name').val(),
                            HouseCode: $('#editunit_housecode').val(),
                            UnitCode: $('#editunit_unitcode').val()
                        })
                });
                // Die Seite neuladen um die Unit zu sehen.
                location.reload();
            }
        }
    });
}

function DeleteUnit(unitID) {
    $.ajax({
        type: 'POST',
        async: false,
        url: 'config/DeleteUnit',
        data:
            ({
                UnitID: unitID
            })
    });
    // Die Seite neuladen.
    location.reload();
}

function ADDPage() {
    var dialog = BootstrapDialog.confirm({
        title: '<b>Eine neue Seite anlegen</b>',
        // Der Inhalt wird hier aus einer Partial geladen!
        message: $('<div></div>').load('partial/AddPage'),
        type: BootstrapDialog.TYPE_DEFAULT,
        btnCancelLabel: 'Abbrechen',
        btnOKLabel: 'Speichern',
        btnOKClass: 'btn-primary',
        callback: function (result) {
            if (result) {
                $.ajax({
                    type: 'POST',
                    async: false,
                    url: 'config/ADDPage',
                    data:
                        ({
                            Name: $('#addpage_name').val(),
                            Sensor: $('#addpage_sensor').val(),
                            Image: document.getElementById('addpage_image').options[document.getElementById('addpage_image').selectedIndex].text
                        })
                });
                // Die Seite neuladen um die Page zu sehen.
                location.reload();
            }
        }
    });
}

function EditPage(pageID) {
    var dialog = BootstrapDialog.confirm({
        title: '<b>Seite bearbeiten</b>',
        // Der Inhalt wird hier aus einer Partial geladen!
        message: $('<div></div>').load('Partial/EditPage?PageID=' + pageID),
        type: BootstrapDialog.TYPE_DEFAULT,
        btnCancelLabel: 'Abbrechen',
        btnOKLabel: 'Speichern',
        btnOKClass: 'btn-primary',
        callback: function (result) {
            if (result) {
                $.ajax({
                    type: 'POST',
                    async: false,
                    url: 'Config/EditPage',
                    data:
                        ({
                            PageID: $('#editpage_id').val(),
                            Name: $('#editpage_name').val(),
                            Sensor: $('#editpage_sensor').val(),
                            Image: document.getElementById('editpage_image').options[document.getElementById('editpage_image').selectedIndex].text
                        })
                });
                // Die Seite neuladen um die Page zu sehen.
                location.reload();
            }
        }
    });
}

function SortPages() {
    var dialog = BootstrapDialog.show({
        title: '<b>Seiten Sortieren</b>',
        // Der Inhalt wird hier aus einer Partial geladen!
        message: $('<div></div>').load('Partial/SortPages'),
        type: BootstrapDialog.TYPE_DEFAULT,
        closable: true,
        closeByBackdrop: false,
        closeByKeyboard: false,
        buttons: [{
            label: 'Schließen',
            action: function (dialogRef) {
                location.reload(true);
                dialogRef.close();
            }
        }]       
    });
}

function UpdatePage(pageID, unitsSort) {
    $.ajax({
        type: 'POST',
        async: true,
        url: 'Config/UpdatePage',
        data:
            ({
                UnitsSort: unitsSort.toString(),
                PageID: pageID
            })
    });
}

function DeletePage(pageID, pageTitle) {

    BootstrapDialog.confirm({
        title: '<b>Seite löschen ?!</b>',
        message: 'Willst Du wirklich die Seite <b>' + pageTitle + '</b> löschen?',
        type: BootstrapDialog.TYPE_WARNING,
        btnCancelLabel: 'Nein',
        btnOKLabel: 'Ja löschen!',
        btnOKClass: 'btn-warning',
        callback: function (result) {
            if (result) {
                $.ajax({
                    type: 'POST',
                    async: false,
                    url: 'Config/DeletePage',
                    data:
                        ({
                            PageID: pageID
                        })
                });
                // Die Seite neuladen
                location.reload();
            }
        }
    });
}

function UpdatePageState(pageID, pageState) {
    $.ajax({
        type: 'POST',
        async: true,
        url: 'Config/UpdatePageState',
        data:
            ({
                PageID: pageID,
                State: pageState
            })
    });
}