// Globe Var
var chart = null;

function GetUnits(_pid, onlyState) {

    var temp = $.parseJSON($.ajax
        ({
            type: 'GET',
            async: false,
            url: '/GetUnits',
            data:
                ({
                    pid: _pid
                })
        }).responseText);

    if (onlyState) {
        for (i in temp) {
            document.getElementById('Unit' + temp[i].iD).src = "/Images/" + temp[i].state + ".png";
            document.getElementById('mobUnit' + temp[i].iD).src = "/Images/" + temp[i].state + ".png";
        }
    }
};


function InfoBannerAvailable(_pid) {
    var temp = $.parseJSON($.ajax
    ({
        type: 'GET',
        async: false,
        url: '/InfoBannerAvailable',
        data:
            ({
                pid: _pid
            })
    }).responseText);

    var _class = document.getElementsByClassName('InfoPannel');

    for (i in _class) {

        if (temp && _class[i].className != null) {
            _class[i].className = _class[i].className.replace(' hidden ', '');
        }

        else if (_class[i].className != null && _class[i].className.indexOf('hidden') < 0) {
            _class[i].className = _class[i].className + ' hidden ';
        }
    }
};


// Async Sensors
function GetSensors(_pid) {
    document.getElementById('TempHeader').innerHTML = 'Heutige Temperaturmessungen <span class="pull-right"><i class="fa fa-refresh fa-spin"></i></span>';
    document.getElementById('BrignessHeader').innerHTML = 'Heutige Lichtmessungen <span class="pull-right"><i class="fa fa-refresh fa-spin"></span></i>';
    document.getElementById('HumidityHeader').innerHTML = 'Heutige Luftfeuchtigkeit <span class="pull-right"><i class="fa fa-refresh fa-spin"></span></i>';
    document.getElementById('SensorVoltage').innerHTML = '<i class="fa fa-refresh fa-spin"></i> ' + document.getElementById('SensorVoltage').innerHTML;
    document.getElementById('LastMeasurement').innerHTML = document.getElementById('LastMeasurement').innerHTML + ' <i class="fa fa-refresh fa-spin"></i>';
    AsyncGetSensors(_pid).done(function (data) {
        var temp = data;
        var SensorTemp = '';
        var SensorBrigness = '';
        var SensorHumidity = '';
        var SensorVoltage = '';
        var LastMeasurement = '';
        // Daten vorhenden? Wenn nicht kein Sensor vorhanden!
        if (temp.temp == '') {

            document.getElementById('SensorVoltage').innerHTML = '';
            document.getElementById('LastMeasurement').innerHTML = 'Kein Raumsensor vorhanden.';
        }
        else {

            SensorTemp = '<li class="list-group-item"><b>Aktuelle-Temperatur:</b> ' + temp.temp + '°C</li>' +
                               '<li class="list-group-item"><b>Maximale-Temperatur:</b> ' + temp.maxTemp + '°C</li>' +
                               '<li class="list-group-item"><b>Durschnitts-Temperatur:</b> ' + temp.aVGTemp + '°C</li>' +
                               '<li class="list-group-item"><b>Minimale-Temperatur:</b> ' + temp.minTemp + '°C</li>';

            SensorBrigness = '<li class="list-group-item"><b>Aktueller-Lichtwert:</b> ' + temp.brightness + '%</li>' +
                                '<li class="list-group-item"><b>Maximaler-Lichtwert:</b> ' + temp.maxBrightness + '%</li>' +
                                '<li class="list-group-item"><b>Durschnitts-Lichtwert:</b> ' + temp.aVGBrightness + '%</li>' +
                                '<li class="list-group-item"><b>Minimaler-Lichtwert:</b> ' + temp.minBrightness + '%</li>';

            SensorHumidity = '<li class="list-group-item"><b>Aktuelle-Luftfeuchtigkeit:</b> ' + temp.humidity + '%</li>' +
                                '<li class="list-group-item"><b>Maximale-Luftfeuchtigkeit:</b> ' + temp.maxHumidity + '%</li>' +
                                '<li class="list-group-item"><b>Durschnitts-Luftfeuchtigkeit:</b> ' + temp.aVGHumidity + '%</li>' +
                                '<li class="list-group-item"><b>Minimale-Luftfeuchtigkeit:</b> ' + temp.minHumidity + '%</li>';

            var dateTime = new Date(Date.parse(temp.lastMeasurement));
            LastMeasurement = 'Letzte Messung am ' + dateTime.toLocaleDateString() + ' um ' + dateTime.toLocaleTimeString();

            if (temp.battVolt <= 3.4) {
                SensorVoltage = 'Sensor Voltage: <b style="color:#D60C0C">' + temp.battVolt + 'V</b>';
            }
            else {
                SensorVoltage = 'Sensor Voltage: ' + temp.battVolt + 'V';
            }


            document.getElementById('TempHeader').innerHTML = 'Heutige Temperaturmessungen';
            document.getElementById('SensorTemp').innerHTML = SensorTemp;

            document.getElementById('BrignessHeader').innerHTML = 'Heutige Lichtmessungen';
            document.getElementById('SensorBrigness').innerHTML = SensorBrigness;

            document.getElementById('HumidityHeader').innerHTML = 'Heutige Luftfeuchtigkeit';
            document.getElementById('SensorHumidity').innerHTML = SensorHumidity;

            document.getElementById('SensorVoltage').innerHTML = SensorVoltage;

            document.getElementById('LastMeasurement').innerHTML = LastMeasurement;
        }
    });
};

function AsyncGetSensors(_pid) {
    return $.ajax
        ({
            type: 'GET',
            async: true,
            url: '/GetSensors',
            data:
                ({
                    pid: _pid
                })
        });
};



function AsyncGetChart(_pid) {
    return $.ajax
        ({
            type: 'GET',
            async: true,
            url: '/GetChart',
            data:
                ({
                    pid: _pid
                })
        });
};

function SetUnitState(_pid, _uid, _state) {
    $.ajax
        ({
            type: 'POST',
            async: false,
            url: '/SetUnitState',
            data:
                ({
                    PageID: _pid,
                    UnitID: _uid,
                    State: _state
                })
        });
    GetUnits(_pid, true);
};

function AsyncGetWeatherChart(timeSpan) {
    return $.ajax
        ({
            type: 'GET',
            async: true,
            url: 'function.php',
            data:
                ({
                    Function: "GetWeatherData" + timeSpan
                })
        });
};

function GetRoomSensorChart(_pid) {
    document.getElementById('ChartHeader').innerHTML = 'Auswertung der heutigen Messungen <span class="pull-right"><i class="fa fa-refresh fa-spin"></i></span>';
    AsyncGetChart(_pid).done(function (data) {
        document.getElementById('ChartHeader').innerHTML = 'Auswertung der heutigen Messungen';
        chart = c3.generate({
            bindto: '#chart',
            data: {
                json: data,
                keys: {
                    x: 'time', // it's possible to specify 'x' when category axis
                    value: ['temperatur', 'helligkeit', 'luftfeuchtigkeit']
                },
                colors: {
                    temperatur: '#ff0000',
                    helligkeit: '#FFDE00',
                    luftfeuchtigkeit: '#0400FF'
                },
                names: {
                    temperatur: 'Temperatur',
                    helligkeit: 'Helligkeit',
                    luftfeuchtigkeit: 'Luftfeuchtigkeit'
                },
                type: 'spline'
            },
            zoom: {
                enabled: true
            },
            axis: {
                x: {
                    type: 'category'
                }
            }
        });
    });
}

function RefreshRoomSensorChart(_pid) {
    AsyncGetChart(_pid).done(function (data) {
        chart.load({
            json: data,
            keys: {
                x: 'time', // it's possible to specify 'x' when category axis
                value: ['temperatur', 'helligkeit', 'luftfeuchtigkeit'],
            }
        });
    });
}